<?php
/**
* @version		$Id: tweet_flexicontent.php 11616 2010-03-20 14:09:52Z sitefaitbienfait $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.error.error' );


//Check if Flexicontent is installed
if (!JComponentHelper::getComponent('com_flexicontent', true)->enabled) {
	JError::raiseWarning('5', 'Flexicontent extension is not installed or not enabled.');
	return;
}

require_once (JPATH_ROOT . DS . 'components' . DS . 'com_flexicontent' . DS . 'helpers' . DS . 'route.php');


class plgSystemTweet_Flexicontent extends JPlugin
{

	protected $login		= '';
	protected $password		= '';
	// db table to get new item id

	function plgSystemTweet_Flexicontent( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		
		// Get Plugin Parameter
		$plugin			=& JPluginHelper::getPlugin('system', 'tweet_flexicontent');
		$pluginParams	= new JParameter($plugin->params);
		
		$this->login				= $pluginParams->get('login', '');
		$this->password				= $pluginParams->get('password', '');
		
	}

	function onAfterRoute()
	{
		global $mainframe;
		$user = & JFactory::getUser();
		//Only execute on administrator
		$base_uri = JURI::base();
		$admin = JString::strrpos($base_uri, '/administrator/');
		if($admin){
			if (FLEXI_ACCESS) {		
				$tweet_access 	= ($user->gid < 25) ? FAccess::checkComponentAccess('com_flexicontent', 'tweet', 'users', $user->gmid) : 1;
				
			} else {
				$tweet_access	= 1;
				
			}
			//If click on TweetItems Button
			if (('com_flexicontent' == JRequest::getVar('option')) && ('TweetItems' == JRequest::getVar('task')) ) {
				
				//get items id
				$cid = JRequest::getVar('cid');
				//Information message
				$information = array();
				 
				if ($tweet_access){
					foreach($cid as $id){
						
						$message = $this->buildMessage($id);
						$retour = $this->postMessage($message);											
						//Get the code retour
						if($retour){
							$information[]="Item ".$id." successfully posted on twitter. <br />";
						}
						else {
							$information[]="Problem with item ".$id;
						}
					}
				}
				else{	
					$information[]=JText::_('ALERTNOTAUTH');
				
				}
				//display the Information message
				for($i=0; $i<count($information); $i++){
					$mainframe->enqueueMessage($information[$i]);
				}
				
			}
			
				
			// Add the Post on twitter button only in the items view
			if (('com_flexicontent' == JRequest::getVar('option')) && ('items' == JRequest::getVar('view')) && $tweet_access) {			
					$document =& JFactory::getDocument();
					$css = "
					span.icon-32-tweet{
						background-image : url(../plugins/system/tweet_flexicontent/images/tweet_flexicontent.png);
					}
					";
					$document->addStyleDeclaration($css);
					
					JToolBarHelper :: custom( 'TweetItems', 'tweet.png', 'tweet.png', 'Post on Twitter', true, false );				
			}
				
		}
		return true;	
	}
	/*	Function BuildMessage
	*	Get the article title and link 
	*	Return a formatted string 
	*
	*/
	private function buildMessage($item_id){
		
		$article =& JTable::getInstance('content');
		$article->load($item_id);
		$cat =& $this->getCategory($article->catid);
		$link = JRoute::_(FlexiContentHelperRoute::getItemRoute($article->id, $article->catid));	
		$full_link = $this->createURL(urlencode($link));
		$message_url= $this->CreateShortUrl($full_link);		
		
		$title = $article->title ;
		$count_link = strlen($message_url);
		
		$title_cut = substr($title, 0, 139-$count_link);
		
		$message = $title_cut ." ". $message_url;
		
		return $message;
	}
	
	private function postMessage($message){
		$url = 'http://twitter.com/statuses/update.xml';
		$curl_handle = curl_init();
		curl_setopt($curl_handle, CURLOPT_URL, "$url");
		curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 2);
		curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl_handle, CURLOPT_POST, 1);
		curl_setopt($curl_handle, CURLOPT_POSTFIELDS, "status=$message");
		curl_setopt($curl_handle, CURLOPT_USERPWD, $this->login . ':' .$this->password);
		$buffer = curl_exec($curl_handle);
		curl_close($curl_handle);
		if (empty($buffer))
			return 0;
			
		else
			return 1;
	}
	function getCategory($id)
	{
		$row =& JTable::getInstance('category');
		$row->load($id);

		return $row;
	}
	/*	Function create URL
	*	return the frontend item url 
	*
	*/
	private function createURL($site_url)
	{
		$base_uri = JURI::base();
		$del_pos = JString::strrpos($base_uri, '/administrator/');
		if (FALSE === $del_pos) {
			$baseurl = JURI::getInstance()->toString(array ('scheme', 'host', 'port'));
		}
		else {
			$baseurl = substr_replace($base_uri, '', $del_pos);
		}
		if ('/' != substr($site_url, 0, 1)) {
			$site_url = '/' . $site_url;
		}
		$url = $baseurl . $site_url;
		return $url;
	}	
	

	/*	Function CreateshortURL with is.gd API
	*	Return a short url
	*/
	function CreateShortURL($longurl) {
		$url = "http://is.gd/api.php";
		$variable = "longurl";
		$shorturl = $this->doCurlRequest($url, $variable, $longurl);
		return $shorturl;
	}
	
	function doCurlRequest($url, $variable, $value) {
		$api = $url."?".$variable."=".$value;
		
		$session = curl_init();
		curl_setopt($session, CURLOPT_URL, $api);
		curl_setopt($session, CURLOPT_RETURNTRANSFER, 1);
		$data = curl_exec($session);
		curl_close($session);
		
		return $data;
	}
	
}	
?>
